function [ alpha ] = KLiMapS_test(n, m, k)

    maxIter=1000;
    %% --  INITIALIZATION  --
    [D DINV true_alpha s] = CreateDict(n,m,k,1,'Real','Gaussian');
 
    ta=sort(abs(true_alpha));
    %% --  INITIALIZATION  --
    
    under=k-ceil(k/2);
    over=k+ceil(0.9*k);
    
    alphaUnder = DINV*s;
    alpha = DINV*s;
    alphaOver = DINV*s;
    
    aUnder=sort(abs(alphaUnder));
    a=sort(abs(alpha));
    aOver=sort(abs(alphaOver));
    
    lambdaUnder = 1/aUnder(end-under);
    lambda = 1/a(end-k);
    lambdaOver = 1/aOver(end-over);

    close all;
    
    lUnder=-[lambdaUnder];
    l=[lambda];
    lOver=[lambdaOver];
    
    %% --  CORE  --
    for i=1:maxIter

        % apply sparsity constraction mapping: increase sparsity
        betaUnder = alphaUnder.*(1-exp(-lambdaUnder.*abs(alphaUnder)));
        beta = alpha.*(1-exp(-lambda.*abs(alpha)));
        betaOver = alphaOver.*(1-exp(-lambdaOver.*abs(alphaOver)));

        % apply the orthogonal projection
        alphaUnder = betaUnder-DINV*(D*betaUnder-s);
        alpha = beta-DINV*(D*beta-s); 
        alphaOver = betaOver-DINV*(D*betaOver-s);
        
        % update the lambda coefficient
        aUnder=sort(abs(alphaUnder));
        a=sort(abs(alpha));
        aOver=sort(abs(alphaOver));
        
        lambdaUnder = 1/aUnder(end-under);
        lambda = 1/a(end-k);
        lambdaOver = 1/aOver(end-over);
        
        lUnder = [lUnder lambdaUnder];
        l = [l lambda];
        lOver = [lOver lambdaOver];
        
        subplot(3,2,1);
        stem(ta,'g');
        hold on;
        title(['k = ' num2str(under)]);
        stem(aUnder)
        stem(numel(alpha)-under,aUnder(numel(alpha)-under),'r');
        hold off;
        subplot(3,2,2);
        semilogy(lUnder)
        hold on
        legend(['\theta = ' num2str(log(lUnder(i+1))-log(lUnder(i)))]);
        hold off;
        
        subplot(3,2,3);
        stem(ta,'g');
        hold on;
        title(['k = ' num2str(k)]);
        stem(a)
        stem(numel(alpha)-k,a(numel(alpha)-k),'r');
        hold off;
        subplot(3,2,4);
        semilogy(l,'r')
        hold on
        legend(['\theta = ' num2str(log(l(i+1))-log(l(i)))]);
        hold off;
        
        subplot(3,2,5);
        stem(ta,'g');
        hold on;
        title(['k = ' num2str(over)]);
        stem(aOver)
        stem(numel(alpha)-over,aOver(numel(alpha)-over),'r');
        hold off;
        subplot(3,2,6);
        semilogy(lOver)
        hold on
        semilogy(l,'r')
        legend(['\theta = ' num2str(log(lOver(i+1))-log(lOver(i)))]);
        hold off;
        
        pause(0.01)
        
    end
    
    %% -- REFINEMENT --

    % final refinements of the solution
    alpha(abs(alpha)<=1/lambda)=0;
    
    idx = alpha~=0;
    D1 = D(:,idx);
    alpha(idx) = alpha(idx) - pinv(D1)*(D1*alpha(idx)-s);
  
    
end



